import sys
import pyglet
import graph
import vm_window
import vm_components
import vm_system
import vm_gameboard
import vm_module
import graph

from vm_module import VMModule

#TODO
# Fix Player Moving
#
# Implement ability to run three program types (Active, Passive, OneShot)
#	See virtmerc doc
#
# Add Buttons for commands - we need the commands first, dont't jump gun
#
# Check we are deleting sprites properly - IMPORTANT WHEN CLEARING BOARD
# Double Click to Center
# Slide to nodes (instead of snap) on board.center_on


# BUILD GRAPH
#
def buildGraph(modules):
	
	# Create Graph of Units
	module_graph= graph.graph()
	for x in range(len(modules)):
		module_graph.add_node(modules[x])
	#endfor

	module_graph.add_edge(modules[0], modules[1])
	module_graph.add_edge(modules[0], modules[2])
	module_graph.add_edge(modules[1], modules[3])
	module_graph.add_edge(modules[1], modules[5])
	module_graph.add_edge(modules[2], modules[3])
	module_graph.add_edge(modules[2], modules[4])
	module_graph.add_edge(modules[3], modules[4])
	module_graph.add_edge(modules[4], modules[5])
	module_graph.add_edge(modules[4], modules[6])
	module_graph.add_edge(modules[4], modules[7])

	return module_graph
#enddef

if (__name__ == "__main__"):

	modules= [
		VMModule("Node0"),
		VMModule("Node1"),
		VMModule("Node2"),
		VMModule("Node3"),
		VMModule("Node4"),
		VMModule("Node5"),
		VMModule("Node6"),
		VMModule("Node7"),
	]

	from vm_components import VMPrompt,VMConsole,VMProcList	
	from vm_gameboard import VMGameBoard

	prompt= VMPrompt()
	console= VMConsole()
	proc_list= VMProcList()
	board= VMGameBoard(buildGraph(modules))
	
	window = vm_window.VMWindow(prompt, console, proc_list, board, resizable=False)
	
	system= vm_system.VMSystem(proc_list, window, board, modules[0])
	
	# handling input/output.
	system.set_print_callback(console.send_text)
	window.set_input_callback(system.read_input)
	
	system.welcome_screen()
	
	pyglet.clock.schedule_interval(system.tick, 0.1)

	pyglet.app.run()
#endif


