import vm_board


class VMGameBoard(vm_board.VMBoard):


	# INIT
	#
	def __init__(self, module_graph, debug=False):
		self.parent= super(VMGameBoard, self)
		self.parent.__init__(module_graph, debug=debug)
		
		self.module_graph= module_graph
		self.player_data= None
		
	#enddef
	
	
	####################################################
	# GAME LOGIC
	#
	#
	
	
	# GET MODULE BY NAME
	# localto= can we see everything or only whats on display
	def get_module_by_name(self, mod_name, god=False):
		for module in self.module_graph:
			if (module.name == mod_name):
				if (self.player_data == None):
					print("WARNING - no player_data set")
				if (god or module in self.module_graph.neighbors(self.player_data[0])):
					return module
				else:
					break
				#endif
			#endif
		#endfor
		return None
	#enddef
	
	
	# PLACE PLAYER
	# place the player on the board
	# Returns True/False
	def place_player(self, module, name="PLAYER1"):
		self.player_data= (module)
		self.parent.place_piece(name, "PLAYER1", module)
		self._show_module(module)
	#enddef
	
	
	# MOVE PLAYER
	#
	# returns True/False
	def move_player(self, module, name="PLAYER1", god=False):
		if (self.player_data == None):
			self.place_player(module)
			return True
		#endif
		
		if (god == False):
			if (module.display != 2):
				print("ERROR - placing on invalid node")
				return False
			#endif
		
			if (module not in self.module_graph.neighbors(self.player_data[0])):
				print("ERROR - placing on non-neighbor node")
				return False
			#endif
		#endif
		
		self.place_player(module)
		return True
	#enddef
	
	
	# ANALYZE MODULE
	#
	def analyze_module(self, module):
		module.analyze()
		self.parent.rerender()
	#enddef
	
	
	# SHOW MODULE
	# draw module and draw its neighbors as unknown
	def _show_module(self, module):
		module.display= 2
		for n_module in self.module_graph.neighbors(module):
			if (n_module.display == 0):
				n_module.display= 1
			#endif
		#endfor

		self.parent.rerender()
	#enddef
#endclass